From 79adf552ad245cdee178816e7fed5e6df7fd5bf7 Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Apr 26 2016 09:25:42 +0000
Subject: [PATCH 446/1001] Adjust the smart_cache_invalidator script to rely on the base widget


The methods present in the base widget allow easy interacting with the
cache database without having to do anything manually.

---

diff --git a/smart_cache_invalidator.py b/smart_cache_invalidator.py
index 7e53851..08737ee 100755
--- a/smart_cache_invalidator.py
+++ b/smart_cache_invalidator.py
@@ -13,11 +13,13 @@ from __future__ import print_function
 import argparse
 import os
 
-import anydbm
+import dogpile.cache
 import fedmsg.config
 import fedmsg.meta
 
+
 import hubs.models
+import hubs.widgets.base
 
 # get the DB session
 fedmsg_config = fedmsg.config.load_config()
@@ -28,34 +30,26 @@ session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
 
 def do_list(args):
     ''' List the different widget for which there is data cached. '''
-    db = anydbm.open(args.cache_db)
-    for key in db.keys():
-        widget_id = key.split('|')[0]
-        widget = hubs.models.Widget.get(session, widget_id)
-        if widget:
+    for widget in session.query(hubs.models.Widget).all():
+        key = hubs.widgets.base.cache_key_generator(widget, **widget.config)
+        result = hubs.widgets.base.cache.get(key, ignore_expiration=True)
+        if not isinstance(result, dogpile.cache.api.NoValue):
             print('- Widget cached {0} (#{1}) in {2}'.format(
-                      widget.hub_id, widget_id, widget.plugin))
-    db.close()
+                      widget.hub_id, widget.idx, widget.plugin))
 
 
 def do_clean(args):
     ''' Clean the widget for which there is data cached. '''
-    for ext in ['.dogpile.lock', '.rw.lock']:
-        filename = args.cache_db + ext
-        if os.path.exists(filename):
-            os.unlink(filename)
-
-    db = anydbm.open(args.cache_db, 'w')
     for widget in args.widgets:
-        for key in db.keys():
-            widget_id = key.split('|')[0]
-            wid_obj = hubs.models.Widget.get(session, widget_id)
-            if widget in [wid_obj.plugin if wid_obj else '', widget_id]:
-                print('- Removing cached {0} (#{1}) in {2}'.format(
-                      widget.hub_id, widget_id, widget.plugin))
-                del(db[key])
-                break
-    db.close()
+        wid_obj = hubs.models.Widget.get(session, widget)
+        if not wid_obj:
+            wid_obj = session.query(cls).filter_by(plugin=widget).first()
+        if not wid_obj:
+            print('No widget found for {0}'.format(widget))
+
+        print('- Removing cached {0} (#{1}) in {2}'.format(
+              wid_obj.hub_id, wid_obj.idx, wid_obj.plugin))
+        result = hubs.widgets.base.invalidate_cache(wid_obj, **wid_obj.config)
 
 
 def setup_parser():

